dojo.require("dijit.layout.ContentPane");
dojo.require("dijit.form.TextBox");
dojo.require("com.ibm.mm.builder.dialog.DialogFooter");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants");
dojo.require("com.ibm.mm.builder.iwidget.SystemWidget");
dojo.declare("com.ibm.mm.builder.pagePropertyEditor",com.ibm.mm.builder.iwidget.SystemTemplatedWidget,{pageId:"",pageTitle:"",pageDesc:"",pageTheme:"",autoWiringEnabled:builderConfig.pageAutoWiringDefault,userModel:null,displayTab:null,isEditCurrentPage:true,onLoad:function(){
this.enablerUtil=com.ibm.mm.builder.utils.enablerUtil;
this.LOGGER=com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.pagePropertyEditor");
this.resourceMessage=com.ibm.mm.builder.coreWidgetsMessages;
this.WID="_"+this.iContext.widgetId+"_";
},onUnload:function(){
dojo.disconnect(this.overHoverHandler);
dojo.disconnect(this.outHoverHandler);
this.overHoverHandler=null;
this.outHoverHandler=null;
},onView:function(){
this.inherited(arguments);
this.pagePropertyAdvanceSection.style.display="none";
dojo.style(this.accountSettingsContent,"display","none");
dojo.style(this.pagePropertiesContent,"display","");
if(!this.overHoverHandler){
this.overHoverHandler=dojo.connect(this.pagePropertyShowChangeOwner,"onmouseover",this.pagePropertyShowChangeOwner,function(){
dojo.addClass(this,"hover");
},true);
}
if(!this.outHoverHandler){
this.outHoverHandler=dojo.connect(this.pagePropertyShowChangeOwner,"onmouseout",this.pagePropertyShowChangeOwner,function(){
dojo.removeClass(this,"hover");
},true);
}
},onDisplayPageProperty:function(_1){
if(builderConfig.isBidi){
this.pagePropertyAdvanceIcon.src=builderConfig.builderPath+"/images/nextRtl.gif";
}else{
this.pagePropertyAdvanceIcon.src=builderConfig.builderPath+"/images/next.gif";
}
if(_1.payload&&_1.payload.pageId){
this.pageId=_1.payload.pageId;
this.editPageInSpaceManager=_1.payload.editPageInSpaceManager;
}else{
this.pageId=_1.payload;
this.editPageInSpaceManager=false;
}
this.isEditCurrentPage=(this.pageId===com.ibm.mm.builder.utils.pageUtil.getCurrentPageId());
if(this.isEditCurrentPage){
this.currentPageModel=com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage();
}
if(this.pageId){
dojo.style(this.accountSettingsContent,"display","none");
dojo.style(this.pagePropertiesContent,"display","");
this.displayTab="pageProperty";
this.initPagePropertyDiv();
this.initThemeSelection();
}else{
dojo.style(this.pagePropertiesContent,"display","none");
dojo.style(this.accountSettingsContent,"display","");
this.displayTab="accountSettings";
this.initAccountSetting();
}
},onPageOwnerChanged:function(_2){
this._displayCurrentOwner();
this._hideChangeOwner();
},getBooleanValue:function(_3){
if(_3===true||_3=="true"){
return true;
}
return false;
},initAccountSetting:function(){
if(com.ibm.mm.builder.utils.userUtil.isLookasideEnabled("com.ibm.mashups.user.AUTO_WIRE_ENABLED_NOTIFICATIONS")){
this.userModel=com.ibm.mm.builder.utils.userUtil.getUserModel();
var _4=com.ibm.mm.builder.utils.userUtil.getCurrentUser();
var v1=_4.getAttribute("com.ibm.mashups.user.AUTO_WIRE_ENABLED_NOTIFICATIONS");
var v2=_4.getAttribute("com.ibm.mashups.user.AUTO_WIRE_DISABLED_NOTIFICATIONS");
this.displaySuccessNotification=this.getBooleanValue(v1);
this.displayDisabledNotification=this.getBooleanValue(v2);
this.displayNotiCheck.checked=this.displaySuccessNotification;
this.notifyMeCheck.checked=this.displayDisabledNotification;
}else{
this.displayNotiCheck.checked=false;
this.notifyMeCheck.checked=false;
this.loginHomeSpaceRadio.checked=false;
this.loginLastPageRadio.checked=true;
this.displayNotiCheck.disabled=true;
this.notifyMeCheck.disabled=true;
}
if(com.ibm.mm.builder.utils.userUtil.isLookasideEnabled("com.ibm.mashups.user.WHERE_TO_GO_WHEN_LOGIN")){
var _5=com.ibm.mm.builder.utils.navigationUtil.isLastPageWhenLogin();
this.loginHomeSpaceRadio.checked=!_5;
this.loginLastPageRadio.checked=_5;
}else{
dojo.style(this.accountSettingsLoginContent,"display","none");
this.loginHomeSpaceRadio.disabled=true;
this.loginLastPageRadio.disabled=true;
}
},initPagePropertyDiv:function(){
this.pageTitle=com.ibm.mm.builder.utils.pageUtil.getUnescapedPageTitle(this.pageId);
this.pageTitleInput.value=this.pageTitle;
this._displayCurrentOwner();
this._hideChangeOwner();
this.pageDesc=com.ibm.mm.builder.utils.pageUtil.getPageDescription(this.pageId);
this.pagePropertyDescription.value=this.pageDesc;
var _6=this.enablerUtil.getPageMetaData("com.ibm.mashups.builder.autoWiringEnabled",this.pageId);
if(_6!==null&&(_6=="true"||_6=="false"||_6===true||_6===false)){
this.autoWiringEnabled=this.getBooleanValue(_6);
}else{
this.autoWiringEnabled=builderConfig.pageAutoWiringDefault;
}
if(this.autoWiringEnabled==true||this.autoWiringEnabled=="true"){
this.autoWiringEnableRadio.click();
}else{
this.autoWiringDisableRadio.click();
}
dojo.query(".tabLabel").forEach(function(_7,_8){
var _9=_7.innerHTML;
var _a=100;
if(!builderConfig.isBidi){
_a=_8===0?100:120;
}
var _b=com.ibm.mm.builder.utils.htmlUtil.getStrWithLimit(_9,_7,_a);
_7.innerHTML=_b;
});
},_displayCurrentOwner:function(){
var _c=com.ibm.mm.builder.utils.acModelUtil.getPageOwner(this.pageId);
if(_c){
this.pagePropertyCurrentOwner.innerHTML=_c.getDisplayName();
this.pageOwnerLabel.style.display="inline";
this.noPageOwnerLabel.style.display="none";
}else{
this.pageOwnerLabel.style.display="none";
this.noPageOwnerLabel.style.display="inline";
}
},canChangeOwner:function(_d){
if(!_d){
return false;
}
var _e=null;
if(dojo.isString(_d)){
_e=com.ibm.mm.builder.utils.pageUtil.getPageLayoutNode(_d);
}
if(_e){
var _f=com.ibm.mm.builder.utils.spaceUtil.getSpaceIdByPageId(_d);
var ac=null;
if(_f){
var _10=com.ibm.mm.builder.utils.spaceUtil.getSpaceNode(_f);
ac=com.ibm.mashups.enabler.ac.AccessControlModelFactory.getAccessControlModel(_10,_e);
}else{
ac=com.ibm.mashups.enabler.ac.AccessControlModelFactory.getAccessControlModel(_e);
}
return ac.confirmSetOwner(_e);
}
return false;
},_hideChangeOwner:function(){
var _11=com.ibm.mm.builder.utils.spaceUtil.getSpaceIdByPageId(this.pageId);
if(!_11||!this.canChangeOwner(this.pageId)){
this.pagePropertyShowChangeOwner.style.display="none";
}else{
this.pagePropertyShowChangeOwner.style.display="inline";
}
},hide:function(){
this._hideMessage();
this.eventService.broadcastEvent("com.ibm.mashups.builder.closeMashupDialog",this.iContext.widgetId);
},initThemeSelection:function(){
this.themeSelection.innerHTML="";
var _12=com.ibm.mm.builder.utils.themeUtil.getThemeId(this.pageId);
var _13=com.ibm.mm.builder.utils.themeUtil.getThemeModel();
var _14=0;
var _15=0;
var _16=_13.iterator();
while(_16.hasNext()){
var _17=_16.next();
var _18=_17.getID();
var _19=com.ibm.mm.builder.utils.themeUtil.getThemeTitle(_17,builderConfig.locale);
this.themeSelection.options.add(new Option(_19,_18));
this.themeSelection.options[this.themeSelection.options.length-1].title=_19;
if(_18==_12){
_15=_16.getCursorPosition()-1;
this.pageTheme=_17.getID();
}
}
this.themeSelection.options[_15].selected=true;
},save:function(){
if(!this.messageControl){
dojo.registerModulePath("com.ibm.lotus.oneui.v100.messages",this.iContext.io.rewriteURI("../dijit-library/oneUI.versionized/messages"));
dojo.require("com.ibm.lotus.oneui.v100.messages.Message");
this.messageControl=new com.ibm.lotus.oneui.v100.messages.Message({messageType:"error"},this._messageBoxNode);
this.messageControl.hide();
}
if(this.displayTab=="pageProperty"){
var _1a=dojo.trim(this.pageTitleInput.value);
var _1b=dojo.trim(this.pagePropertyDescription.value);
var _1c=this.themeSelection.value;
if(this._savePageProperty(_1a,_1b,_1c)){
var _1d=com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants;
dojo.publish(_1d.Topic.Space.refresh,[_1d.Action.EDIT_PAGE,{pageId:this.pageId}]);
com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.layoutRefresh");
this.hide();
}
}else{
if(this.displayTab=="accountSettings"){
this._saveAccountSettings();
this.hide();
}
}
},_saveAccountSettings:function(){
if(com.ibm.mm.builder.utils.userUtil.isLookasideEnabled()){
var _1e=this.userModel.findCurrentUser().start();
var _1f=false;
if(com.ibm.mm.builder.utils.userUtil.isLookasideEnabled("com.ibm.mashups.user.AUTO_WIRE_ENABLED_NOTIFICATIONS")){
if(this.displaySuccessNotification.toString()!=_1e.getAttribute("com.ibm.mashups.user.AUTO_WIRE_ENABLED_NOTIFICATIONS")){
_1e.setAttribute("com.ibm.mashups.user.AUTO_WIRE_ENABLED_NOTIFICATIONS",this.displaySuccessNotification.toString());
_1f=true;
}
}
if(com.ibm.mm.builder.utils.userUtil.isLookasideEnabled("com.ibm.mashups.user.AUTO_WIRE_DISABLED_NOTIFICATIONS")){
if(this.displayDisabledNotification.toString()!=_1e.getAttribute("com.ibm.mashups.user.AUTO_WIRE_DISABLED_NOTIFICATIONS")){
_1e.setAttribute("com.ibm.mashups.user.AUTO_WIRE_DISABLED_NOTIFICATIONS",this.displayDisabledNotification.toString());
_1f=true;
}
}
if(com.ibm.mm.builder.utils.userUtil.isLookasideEnabled("com.ibm.mashups.user.WHERE_TO_GO_WHEN_LOGIN")){
if(this.onLoginValue&&this.onLoginValue!=_1e.getAttribute("com.ibm.mashups.user.WHERE_TO_GO_WHEN_LOGIN")){
_1e.setAttribute("com.ibm.mashups.user.WHERE_TO_GO_WHEN_LOGIN",this.onLoginValue);
_1f=true;
}
}
if(_1f){
try{
this.userModel.commit().start();
}
catch(e){
this.LOGGER.severe("_saveAccountSettings",dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_ACCOUNT_SETTING_SAVE_FAIL,[e.message]));
}
}
}
},_verifyDescription:function(_20){
var _21=com.ibm.mm.builder.utils.pageUtil.isPageDescriptionLengthExceed(_20);
var _22=null;
if(_21>0){
_22=this.resourceMessage.E_PAGE_UTIL_INVALID_DESCRIPTION_LENGTH_1;
if(typeof (_22)==="undefined"){
dojo.requireLocalization("com.ibm.mm.builder","coreWidgetsMessages","en");
var _23=dojo.i18n.getLocalization("com.ibm.mm.builder","coreWidgetsMessages","en");
_22=_23.E_PAGE_UTIL_INVALID_DESCRIPTION_LENGTH_1;
}
if(typeof (_22)==="undefined"){
_22="BMWMB0120E:The page description is limited to ${0} characters. Shorten your description and save again.";
}
_22=dojo.string.substitute(_22,[_21]);
this.messageControl.attr("message",_22);
this.messageControl.show();
return false;
}else{
return true;
}
},_savePageProperty:function(_24,_25,_26){
if(!com.ibm.mm.builder.utils.pageUtil.validatePageName(_24)){
return false;
}
if(!this._verifyDescription(_25)){
return false;
}
if(this.autoWiringEnabled!=this.autoWiringEnableRadio.checked){
this.autoWiringEnabled=this.autoWiringEnableRadio.checked;
if(this.isEditCurrentPage){
this.currentPageModel.setAutoWiringEnablement(this.autoWiringEnabled);
}
this.enablerUtil.setPageMetaData(com.ibm.mm.builder.constant.autoWiringEnabled,this.autoWiringEnabled.toString(),this.pageId);
}
var _27=(_24!=this.pageTitle);
var _28=(_25!=this.pageDesc);
if(!_27&&!_28&&_26==this.pageTheme){
return true;
}
var _29=com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
var _2a=_29.find(this.pageId).start();
_2a.setTitle(_24,dojo.locale);
var _2b=ibmConfig["default.locale"];
if(dojo.locale!=_2b&&!_2a.getTitle(_2b)){
_2a.setTitle(_24,_2b);
}
_2a.setDescription(_25,dojo.locale);
this.pageTitle=_24;
if(this.pageTheme!=_26){
themeChanged=true;
_2a.setTheme(_26);
this.pageTheme=_26;
this.eventService.broadcastEvent("com.ibm.mashups.builder.savePage");
var _2c=_29.getLayoutModel(this.pageId);
if(!_2c){
this.LOGGER.severe("_savePageProperty",com.ibm.mm.builder.coreWidgetsMessages.E_EDITPAGE_SAVE_ERROR_0);
return false;
}
var _2d=_2c.getRoot().start();
var _2e=_2d.getMetaDataNames();
this.enablerUtil.removePageMetaData(_2e,this.pageId);
if(this.editPageInSpaceManager){
this.eventService.broadcastEvent("com.ibm.mashups.builder.spacemanager.pageThemeChanged",{pageId:this.pageId,pageTitle:this.pageTitle,pageDesc:_25});
}else{
setTimeout(function(){
window.location.reload();
},1000);
}
}else{
if(_28||_27){
if(this.isEditCurrentPage&&_27){
this.eventService.broadcastEvent("com.ibm.mashups.builder.updatePageTitle",this.pageTitle);
}
if(_27){
this.eventService.broadcastEvent("com.ibm.mashups.builder.refreshNavigation");
}
var _2f=_29.commit();
_2f.setFinishedCallback(dojo.hitch(this,function(x,_30){
if(_30==200||_30==201){
this.eventService.broadcastEvent("com.ibm.mashups.builder.refreshNavigation");
}else{
this.LOGGER.severe("_savePageProperty","Cannot save the navigation model",arguments);
}
}));
_2f.start();
}
}
return true;
},_showMessage:function(_31,_32){
if(!this.messageControl){
dojo.registerModulePath("com.ibm.lotus.oneui.v100.messages",this.iContext.io.rewriteURI("../dijit-library/oneUI.versionized/messages"));
dojo.require("com.ibm.lotus.oneui.v100.messages.Message");
var wid="_"+this.iContext.widgetId+"_";
var _33=dojo.byId(wid+"messageBox");
this.messageControl=new com.ibm.lotus.oneui.v100.messages.Message({messageType:"error"},_33);
}
this.messageControl.attr({"message":_31,"messageType":_32||"error"});
this.messageControl.show();
},_hideMessage:function(){
if(this.messageControl){
this.messageControl.hide();
}
},onClickAdvance:function(){
var _34=this.pagePropertyAdvanceSection;
if(dojo.style(_34,"display")==="none"){
dojo.attr(this.pagePropertyAdvanceIcon,"src",builderConfig.builderPath+"/images/nextdown.gif");
dojo.fx.wipeIn({node:_34,duration:500,onEnd:function(){
if(dojo.isIE){
dojo.removeClass("pageProperty_section_advance",_34);
dojo.addClass("pageProperty_section_advance",_34);
}
}}).play();
}else{
if(builderConfig.isBidi){
dojo.attr(this.pagePropertyAdvanceIcon,"src",builderConfig.builderPath+"/images/nextRtl.gif");
}else{
dojo.attr(this.pagePropertyAdvanceIcon,"src",builderConfig.builderPath+"/images/next.gif");
}
dojo.fx.wipeOut({node:_34,duration:500,onEnd:dojo.hitch(this,function(){
})}).play();
}
com.ibm.mm.builder.utils.htmlUtil.truncateAllChildNodesWord(this.pagePropertyAdvanceSection);
},onDisplayNotiClicked:function(_35){
this.displaySuccessNotification=_35.target.checked;
},onNotifyMeClicked:function(_36){
this.displayDisabledNotification=_36.target.checked;
},onLogin:function(_37){
this.onLoginValue=_37.target.value;
},showChangeOwner:function(){
var _38={widgetTypeId:"changeOwner",eventName:"com.ibm.mashups.builder.changeOwner",eventPayload:this.pageId,dialogParam:{title:this.cws.I_CHANGE_PAGE_OWNER,nodeWidth:"400px",hasRightBottomResizer:false}};
this.eventService.broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog",_38);
}});

